Loading...
Searching...
No Matches
Opm::RegularizedBrooksCorey< TraitsT, ParamsT > Class Template Reference

Implementation of the regularized Brooks-Corey capillary pressure / relative permeability <-> saturation relation. More...

`#include <RegularizedBrooksCorey.hpp>`

Inheritance diagram for Opm::RegularizedBrooksCorey< TraitsT, ParamsT >:

## Public Types

typedef TraitsT | Traits
typedef ParamsT | Params
typedef Traits::Scalar | Scalar

## Static Public Member Functions

template<class Container, class FluidState>
static void | capillaryPressures (Container &values, const Params &params, const FluidState &fs)
| The capillary pressure-saturation curves depending on absolute saturations.
template<class Container, class FluidState>
static void | saturations (Container &values, const Params &params, const FluidState &fs)
| Calculate the saturations of the phases starting from their pressure differences.
template<class Container, class FluidState>
static void | relativePermeabilities (Container &values, const Params &params, const FluidState &fs)
| The relative permeability-saturation curves depending on absolute saturations.
template<class FluidState, class Evaluation = typename FluidState::Scalar>
static Evaluation | pcnw (const Params &params, const FluidState &fs)
| A regularized Brooks-Corey capillary pressure-saturation curve.
template<class Evaluation>
static Evaluation | twoPhaseSatPcnw (const Params &params, const Evaluation &Sw)
template<class FluidState, class Evaluation = typename FluidState::Scalar>
static Evaluation | Sw (const Params &params, const FluidState &fs)
| A regularized Brooks-Corey saturation-capillary pressure curve.
template<class Evaluation>
static Evaluation | twoPhaseSatSw (const Params &params, const Evaluation &pcnw)
template<class FluidState, class Evaluation = typename FluidState::Scalar>
static Evaluation | Sn (const Params &params, const FluidState &fs)
| Calculate the non-wetting phase saturations depending on the phase pressures.
template<class Evaluation>
static Evaluation | twoPhaseSatSn (const Params &params, const Evaluation &pcnw)
template<class FluidState, class Evaluation = typename FluidState::Scalar>
static Evaluation | krw (const Params &params, const FluidState &fs)
| Regularized version of the relative permeability of the wetting phase of the Brooks-Corey curves.
template<class Evaluation>
static Evaluation | twoPhaseSatKrw (const Params &params, const Evaluation &Sw)
template<class Evaluation>
static Evaluation | twoPhaseSatKrwInv (const Params &params, const Evaluation &krw)
template<class FluidState, class Evaluation = typename FluidState::Scalar>
static Evaluation | krn (const Params &params, const FluidState &fs)
| Regularized version of the relative permeability of the non-wetting phase of the Brooks-Corey curves.
template<class Evaluation>
static Evaluation | twoPhaseSatKrn (const Params &params, const Evaluation &Sw)
template<class Evaluation>
static Evaluation | twoPhaseSatKrnInv (const Params &params, const Evaluation &krn)

## Static Public Attributes

static const bool | implementsTwoPhaseApi = true
| Specify whether this material law implements the two-phase convenience API.
static const bool | implementsTwoPhaseSatApi = true
| Specify whether this material law implements the two-phase convenience API which only depends on the phase saturations.
static const bool | isSaturationDependent = true
| Specify whether the quantities defined by this material law are saturation dependent.
static const bool | isPressureDependent = false
| Specify whether the quantities defined by this material law are dependent on the absolute pressure.
static const bool | isTemperatureDependent = false
| Specify whether the quantities defined by this material law are temperature dependent.
static const bool | isCompositionDependent = false
| Specify whether the quantities defined by this material law are dependent on the phase composition.

## Detailed Description

template<class TraitsT, class ParamsT = RegularizedBrooksCoreyParams<TraitsT>>
class Opm::RegularizedBrooksCorey< TraitsT, ParamsT >

Implementation of the regularized Brooks-Corey capillary pressure / relative permeability <-> saturation relation.

This class bundles the "raw" curves as static members and doesn't concern itself converting absolute to effective saturations and vice versa.

In order to avoid very steep gradients the marginal values are "regularized". This means that in stead of following the curve of the material law in these regions, some linear approximation is used. Doing this is not worse than following the material law. E.g. for very low wetting phase values the material laws predict infinite values for which is completely unphysical. In case of very high wetting phase saturations the difference between regularized and "pure" material law is not big.

Regularizing has the additional benefit of being numerically friendly: Newton's method does not like infinite gradients.

The implementation is accomplished as follows:

- check whether we are in the range of regularization
  - yes: use the regularization
  - no: forward to the standard material law.

See also
  BrooksCorey

## Member Function Documentation

## capillaryPressures()

template<class TraitsT, class ParamsT = RegularizedBrooksCoreyParams<TraitsT>>
template<class Container, class FluidState>

void Opm::RegularizedBrooksCorey< TraitsT, ParamsT >::capillaryPressures | ( | Container & | values,
|  | const Params & | params,
|  | const FluidState & | fs )

inline static

The capillary pressure-saturation curves depending on absolute saturations.

Parameters

  values | A random access container which stores the relative pressure of each fluid phase.
  params | The parameter object expressing the coefficients required by the material law.
  fs | The fluid state for which the capillary pressure ought to be calculated

## krn()

template<class TraitsT, class ParamsT = RegularizedBrooksCoreyParams<TraitsT>>
template<class FluidState, class Evaluation = typename FluidState::Scalar>

Evaluation Opm::RegularizedBrooksCorey< TraitsT, ParamsT >::krn | ( | const Params & | params,
|  | const FluidState & | fs )

inline static

Regularized version of the relative permeability of the non-wetting phase of the Brooks-Corey curves.

The approach for regularization is very similar to the one of the capillary pressure, but it does not avoid kinks:

- For wetting phase saturations between 0 and 1, use the unregularized Brooks-Corey non-wetting phase relative permeability
- For wetting phase saturations smaller than 0, return 1
- For wetting phase saturations larger than 1, return 0

See also
  BrooksCorey::krn

## krw()

template<class TraitsT, class ParamsT = RegularizedBrooksCoreyParams<TraitsT>>
template<class FluidState, class Evaluation = typename FluidState::Scalar>

Evaluation Opm::RegularizedBrooksCorey< TraitsT, ParamsT >::krw | ( | const Params & | params,
|  | const FluidState & | fs )

inline static

Regularized version of the relative permeability of the wetting phase of the Brooks-Corey curves.

The approach for regularization is very similar to the one of the capillary pressure, but it does not avoid kinks:

- For wetting phase saturations between 0 and 1, use the unregularized Brooks-Corey wetting phase relative permeability
- For wetting phase saturations smaller than 0, return 0
- For wetting phase saturations larger than 1, return 1

See also
  BrooksCorey::krw

## pcnw()

template<class TraitsT, class ParamsT = RegularizedBrooksCoreyParams<TraitsT>>
template<class FluidState, class Evaluation = typename FluidState::Scalar>

Evaluation Opm::RegularizedBrooksCorey< TraitsT, ParamsT >::pcnw | ( | const Params & | params,
|  | const FluidState & | fs )

inline static

A regularized Brooks-Corey capillary pressure-saturation curve.

This is a regularized variant of the Brooks-Corey curve:

- For wetting phase saturations lower than the threshold saturation, the curve is extrapolated using a straight line exhibiting the slope unregularized capillary pressure curve at the threshold saturation.
- For wetting phase saturations larger than 1, the curve is extrapolated using a straight line that exhibits the slope of the unregularized curve at

See also
  BrooksCorey::pcnw

## relativePermeabilities()

template<class TraitsT, class ParamsT = RegularizedBrooksCoreyParams<TraitsT>>
template<class Container, class FluidState>

void Opm::RegularizedBrooksCorey< TraitsT, ParamsT >::relativePermeabilities | ( | Container & | values,
|  | const Params & | params,
|  | const FluidState & | fs )

inline static

The relative permeability-saturation curves depending on absolute saturations.

Parameters

  values | A random access container which stores the relative permeability of each fluid phase.
  params | The parameter object expressing the coefficients required by the material law.
  fs | The fluid state for which the relative permeabilities ought to be calculated

## Sw()

template<class TraitsT, class ParamsT = RegularizedBrooksCoreyParams<TraitsT>>
template<class FluidState, class Evaluation = typename FluidState::Scalar>

Evaluation Opm::RegularizedBrooksCorey< TraitsT, ParamsT >::Sw | ( | const Params & | params,
|  | const FluidState & | fs )

inline static

A regularized Brooks-Corey saturation-capillary pressure curve.

This is the inverse of the pcnw() method.

The documentation for this class was generated from the following file:

- opm/material/fluidmatrixinteractions/RegularizedBrooksCorey.hpp